<template>
    <v-container>
        <v-row>
            <v-col>
                <div class="field-label">{{ $t('search_', [$t('product_', [$t('name')])]) }}</div>
                <v-autocomplete
                    v-model="selected.product"
                    :items="products"
                    :search-input.sync="search"
                    :loading="loading"
                    item-text="name"
                    return-object
                    outlined
                    hide-no-data
                    hide-details
                ></v-autocomplete>
            </v-col>
        </v-row>
        <v-row v-if="!!selected.product">
            <v-col>
                <v-expand-transition>
                    <v-card>
                        <v-card-text>
                            <validation-observer ref="observer">
                                <v-row>
                                    <v-col class="d-flex justify-center">
                                        <v-img
                                            :src="selected.product.images[0].url"
                                            max-width="180"
                                        ></v-img>
                                    </v-col>
                                </v-row>
                                <v-row>
                                    <v-col>
                                        <div class="field-label">{{ $t('product_', [$t('name')]) }}</div>
                                        <v-text-field
                                            :value="selected.product.name"
                                            outlined
                                            hide-details
                                            readonly
                                        ></v-text-field>
                                    </v-col>
                                    <v-col>
                                        <div class="field-label">{{ $t('amount') }}</div>
                                        <v-text-field
                                            :value="pricing(selected.product.pricing).price"
                                            prefix="MYR"
                                            outlined
                                            hide-details
                                            readonly
                                        ></v-text-field>
                                    </v-col>
                                </v-row>
                                <v-row>
                                    <v-col>
                                        <validation-provider v-slot="{ errors }" name="variant" rules="required">
                                            <v-radio-group
                                                v-model="selected.stock"
                                                :error-messages="errors"
                                            >
                                                <v-radio
                                                    v-for="stock in selected.product.stocks"
                                                    :key="stock.id"
                                                    :label="stock.option_combination + ' (' + stock.inventories_count + ')'"
                                                    :value="stock"
                                                    :disabled="!!!stock.inventories_count"
                                                ></v-radio>
                                            </v-radio-group>
                                        </validation-provider>
                                    </v-col>
                                </v-row>
                                <v-row>
                                    <v-col>
                                        <validation-provider v-slot="{ errors }" name="quantity">
                                            <div class="field-label">{{ $t('quantity') }}</div>
                                            <v-slider
                                                v-model="selected.quantity"
                                                :error-messages="errors"
                                                min="1"
                                                max="10"
                                                class="slider"
                                                thumb-color="primary"
                                                thumb-label="always"
                                                step="1"
                                            >
                                            </v-slider>
                                        </validation-provider>
                                    </v-col>
                                </v-row>
                                <v-row justify="center">
                                    <v-col cols="4">
                                        <v-btn
                                            @click="confirmSelectedItem"
                                            color="primary"
                                            block
                                        >
                                            {{ $t('confirm') }}
                                        </v-btn>
                                    </v-col>
                                </v-row>
                            </validation-observer>
                        </v-card-text>
                    </v-card>
                </v-expand-transition>
            </v-col>
        </v-row>
        <v-row v-if="items.length">
            <v-col cols="12">
                <v-list>
                    <v-list-item
                        v-for="item in items"
                        :key="item.uuid"
                    >
                        <v-list-item-avatar tile size="80">
                            <v-img :src="item.product.images[0].url"></v-img>
                        </v-list-item-avatar>
                        <v-list-item-content class="text-right">
                            <span>{{ item.product.name }}</span>
                            <span>{{ item.stock.option_combination }}</span>
                        </v-list-item-content>
                        <v-list-item-content class="text-right">
                            <span>x {{ item.quantity }}</span>
                        </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                        <v-list-item-content></v-list-item-content>
                        <v-list-item-content class="text-right">
                            <span>{{ $t('amount') }}</span>
                        </v-list-item-content>
                        <v-list-item-content class="text-right">
                            <span>MYR {{ totalAmount | currency }}</span>
                        </v-list-item-content>
                    </v-list-item>
                </v-list>
            </v-col>
        </v-row>
        <v-row v-if="items.length">
            <v-col cols="12">
                <v-checkbox
                    class="mt-0"
                    v-model="defaultAddress"
                    :label="$t('use_default_address')"
                    hide-details="auto"
                    :true-value="true"
                    :false-value="false"
                ></v-checkbox>
            </v-col>
        </v-row>
        <v-row v-if="!defaultAddress">
            <v-col>
                <address-form
                    class="pa-0"
                    ref="address"
                    v-model="shipping_address"
                ></address-form>
            </v-col>
        </v-row>
        <v-row v-if="items.length" justify="center">
            <v-col class="d-flex" cols="4">
                <v-btn
                    @click="onCreateOrder"
                    :loading="loading"
                    color="primary"
                >
                    {{ $t('checkout') }}
                </v-btn>
            </v-col>
        </v-row>
    </v-container>
</template>

<script>
    import util from "../../../mixins/util";
    import shortid from 'shortid';
    import { ValidationObserver, ValidationProvider } from "vee-validate";
    import { mapMutations } from "vuex";
    import AddressForm from "../address/AddressForm";
    import OrderItem from "./OrderItem";

    export default {
        name: 'OrderCreation',
        mixins: [ util ],
        props: ['id'],
        components: {
            OrderItem,
            AddressForm,
            ValidationObserver,
            ValidationProvider
        },
        data: () => ({
            search: '',
            products: [],
            selected: {
                product: null,
                stock: null,
                quantity: 0
            },
            defaultAddress: true,
            loading: false,
            items: [],
            shipping_address: {
                first_name: '',
                last_name: '',
                mobile: '',
                company: '',
                address_1: '',
                address_2: '',
                city: '',
                state: '',
                country: '',
                postcode: ''
            }
        }),
        watch: {
            search(val) {
                if(!val) return;

                if(this.loading) return;

                this.fetchProducts(val)
                    .then(({ items }) => {
                        this.products = items;
                    })
            }
        },
        computed: {
            totalAmount() {
                return _.sumBy(this.items, (item) => {
                    return this.pricing(item.product.pricing).price;
                });
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            fetchProducts(search) {
                this.loading = true;

                return new Promise((resolve, reject) => {
                    axios.get('api/products', {
                            params: {
                                itemsPerPage: -1,
                                search: search,
                            }
                        })
                        .then(response => {
                            let items = response.data.data;
                            resolve({ items });
                        })
                        .catch(error => {
                            reject(error.response.data);
                        })
                        .finally(() => {
                            this.loading = false;
                        });
                });
            },
            confirmSelectedItem() {
                this.$refs.observer
                    .validate()
                    .then((valid) => {
                        if(valid) {
                            const clone = _.cloneDeep({
                                uuid: shortid.generate(),
                                ...this.selected
                            });

                            this.items.push(clone);
                            this.selected.product = null;
                            this.selected.stock = null;
                            this.selected.quantity = 0;
                        }
                    });
            },
            createOrder() {
                this.loading = true;

                const items = this.items.map((i) => {
                    return {
                        product_id: i.product.id,
                        product_stock_id: i.stock.id,
                        quantity: i.quantity,
                    }
                });

                axios.post(`api/orders/${this.id}`, {
                    shipping_address: this.defaultAddress ? undefined : this.shipping_address,
                    currency: 'myr',
                    items: items
                })
                    .then(({ data }) => {
                        this.success(this.$t('order_action.created'));
                        this.$emit('created', data);
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },
            async onCreateOrder() {
                if(!this.defaultAddress) {
                    const valid = await this.$refs.address.validate();
                    if(valid) {
                        this.createOrder();
                    }
                }
                else {
                    this.createOrder();
                }
            }
        }
    }
</script>

<style scoped>

</style>
